"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getColumnTypePlain = exports.getColumnType = exports.generate = void 0;
var tslib_1 = require("tslib");
require("@typed-query-builder/sql-mssql");
function generate(conn, options) {
    if (options === void 0) { options = {}; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var inTables, opt, outTables, _a, _b, inTable, outTable, inColumns, _c, _d, inColumn, outColumn, columnDifferences, _e, _f, col, _g, _h, col, e_1_1;
        var e_1, _j, e_2, _k, e_3, _l, e_4, _m;
        return tslib_1.__generator(this, function (_o) {
            switch (_o.label) {
                case 0: return [4 /*yield*/, conn.query("\n    SELECT \n      name, \n      object_id \n    FROM sys.Tables\n  ")];
                case 1:
                    inTables = _o.sent();
                    opt = tslib_1.__assign({ tableNameAlias: function (x) { return x; }, tableVariableAlias: function (x) { return x; }, columnNameAlias: function (x) { return x; }, tab: '\\t', tabDepth: 0, newline: '\n' }, options);
                    outTables = [];
                    _o.label = 2;
                case 2:
                    _o.trys.push([2, 7, 8, 9]);
                    _a = tslib_1.__values(inTables.recordset), _b = _a.next();
                    _o.label = 3;
                case 3:
                    if (!!_b.done) return [3 /*break*/, 6];
                    inTable = _b.value;
                    outTable = {
                        table: inTable.name,
                        tableAlias: opt.tableNameAlias(inTable.name),
                        tableVariable: opt.tableVariableAlias(inTable.name),
                        columns: [],
                        tableDefinition: '',
                        primary: [],
                    };
                    return [4 /*yield*/, conn.query("\n      SELECT \n        c.name, \n        CASE \n          WHEN c.max_length <> -1 AND t.name IN ('nchar', 'nvarchar') \n          THEN c.max_length / 2\n          ELSE c.max_length\n        END AS max_length,\n        c.user_type_id, \n        c.precision, \n        c.scale, \n        c.is_nullable,\n        t.name AS type,\n        CASE \n          WHEN t.max_length <> -1 AND t.name IN ('nchar', 'nvarchar') \n          THEN t.max_length / 2\n          ELSE t.max_length\n        END AS type_max_length,\n        t.precision AS type_precision,\n        t.scale AS type_scale,\n        (SELECT COUNT(*) \n          FROM sys.Index_Columns AS ic \n          INNER JOIN sys.Indexes AS i \n            ON i.index_id = ic.index_id \n            AND i.object_id = c.object_id\n          WHERE ic.column_id = c.column_id \n            AND i.is_primary_key = 1 \n            AND ic.object_id = c.object_id\n        ) AS [primary]\n      FROM sys.Columns AS c\n      INNER JOIN sys.Types AS t ON t.user_type_id = c.user_type_id\n      WHERE object_id = " + inTable.object_id + "\n    ")];
                case 4:
                    inColumns = _o.sent();
                    try {
                        for (_c = (e_2 = void 0, tslib_1.__values(inColumns.recordset)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            inColumn = _d.value;
                            outColumn = {
                                column: inColumn.name,
                                columnAlias: opt.columnNameAlias(inColumn.name),
                                columnType: getColumnType(inColumn),
                            };
                            if (inColumn.primary) {
                                outTable.primary.push(outColumn.columnAlias);
                            }
                            outTable.columns.push(outColumn);
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_k = _c.return)) _k.call(_c);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    outTable.tableDefinition += repeat(opt.tab, opt.tabDepth) + ("export const " + outTable.tableVariable + " = table({" + opt.newline);
                    outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 1) + ("name: " + quote(outTable.tableAlias) + "," + opt.newline);
                    if (outTable.tableAlias !== outTable.table) {
                        outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 1) + ("table: " + quote(outTable.table) + "," + opt.newline);
                    }
                    outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 1) + ("primary: [" + outTable.primary.map(quote).join(', ') + "]," + opt.newline);
                    outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 1) + ("fields: {" + opt.newline);
                    columnDifferences = 0;
                    try {
                        for (_e = (e_3 = void 0, tslib_1.__values(outTable.columns)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            col = _f.value;
                            outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 2) + (prop(col.columnAlias) + ": " + JSON.stringify(col.columnType).replace(',', ', ') + "," + opt.newline);
                            if (col.columnAlias !== col.column) {
                                columnDifferences++;
                            }
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (_f && !_f.done && (_l = _e.return)) _l.call(_e);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                    outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 1) + ("}," + opt.newline);
                    if (columnDifferences !== 0) {
                        outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 1) + ("fieldColumn: {" + opt.newline);
                        try {
                            for (_g = (e_4 = void 0, tslib_1.__values(outTable.columns)), _h = _g.next(); !_h.done; _h = _g.next()) {
                                col = _h.value;
                                if (col.columnAlias !== col.column) {
                                    outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 2) + (prop(col.columnAlias) + ": " + quote(col.column) + "," + opt.newline);
                                }
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (_h && !_h.done && (_m = _g.return)) _m.call(_g);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        outTable.tableDefinition += repeat(opt.tab, opt.tabDepth + 1) + ("}," + opt.newline);
                    }
                    outTable.tableDefinition += repeat(opt.tab, opt.tabDepth) + "});";
                    outTables.push(outTable);
                    _o.label = 5;
                case 5:
                    _b = _a.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_1_1 = _o.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (_b && !_b.done && (_j = _a.return)) _j.call(_a);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 9: return [2 /*return*/, outTables];
            }
        });
    });
}
exports.generate = generate;
function getColumnType(col) {
    var plain = getColumnTypePlain(col);
    return col.is_nullable
        ? ['NULL', plain]
        : plain;
}
exports.getColumnType = getColumnType;
function getColumnTypePlain(col) {
    switch (col.type) {
        case 'bigint': return 'BIGINT';
        case 'binary': return ['BINARY', col.max_length];
        case 'bit': return 'BIT';
        case 'char': return ['CHAR', col.max_length];
        case 'date': return 'DATE';
        case 'datetime': return 'TIMESTAMP';
        case 'datetime2': return 'TIMESTAMP';
        case 'datetimeoffset': return { timezoned: 'TIMESTAMP' };
        case 'decimal': return ['DECIMAL', col.scale, col.precision];
        case 'float': return 'FLOAT';
        case 'geography': return 'GEOMETRY';
        case 'geometry': return 'GEOMETRY';
        case 'image': return 'BLOB';
        case 'int': return col.max_length === col.type_max_length
            ? 'INT'
            : ['INT', col.max_length];
        case 'money': return 'MONEY';
        case 'nchar': return ['NCHAR', col.max_length];
        case 'ntext': return 'NTEXT';
        case 'numeric': return col.scale !== col.type_scale && col.precision !== col.type_precision
            ? 'NUMERIC'
            : col.precision !== col.type_precision
                ? ['NUMERIC', col.scale]
                : ['NUMERIC', col.scale, col.precision];
        case 'nvarchar': return col.max_length === -1 ? 'NTEXT' : ['NVARCHAR', col.max_length];
        case 'real': return 'FLOAT';
        case 'smalldatetime': return 'TIMESTAMP';
        case 'smallint': return col.max_length === col.type_max_length
            ? 'SMALLINT'
            : ['SMALLINT', col.max_length];
        case 'smallmoney': return 'SMALLMONEY';
        case 'text': return 'TEXT';
        case 'time': return 'TIME';
        case 'timestamp': return 'TIMESTAMP';
        case 'tinyint': return col.max_length === col.type_max_length
            ? 'TINYINT'
            : ['TINYINT', col.max_length];
        case 'uniqueidentifier': return 'UUID';
        case 'varbinary': return ['VARBINARY', col.max_length];
        case 'varchar': return col.max_length === -1 ? 'TEXT' : ['VARCHAR', col.max_length];
        case 'xml': return 'XML';
    }
    return 'ANY';
}
exports.getColumnTypePlain = getColumnTypePlain;
function repeat(x, n) {
    var r = '';
    while (--n >= 0) {
        r += x;
    }
    return r;
}
function prop(x) {
    return /^[a-z_$][a-z0-9_]+$/i.test(x) ? x : quote(x);
}
function quote(x) {
    return "'" + x.replace("'", "\\'") + "'";
}
//# sourceMappingURL=generator.js.map