"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var builder_1 = require("@typed-query-builder/builder");
var sql_mssql_1 = require("@typed-query-builder/sql-mssql");
sql_mssql_1.DialectMssql.setResultParser(builder_1.QueryJson, function (result, q) {
    if (builder_1.isString(result)) {
        result = JSON.parse(result);
    }
    if (builder_1.isValue(result)) {
        result = sql_mssql_1.DialectMssql.getResult(q.json, result);
    }
    return result;
});
sql_mssql_1.DialectMssql.setResultParser(builder_1.QuerySelect, function (records, q) {
    var e_1, _a, e_2, _b;
    try {
        for (var records_1 = tslib_1.__values(records), records_1_1 = records_1.next(); !records_1_1.done; records_1_1 = records_1.next()) {
            var record = records_1_1.value;
            try {
                for (var _c = (e_2 = void 0, tslib_1.__values(q._criteria.selects)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var select = _d.value;
                    if (builder_1.isValue(record[select.alias])) {
                        record[select.alias] = sql_mssql_1.DialectMssql.getResult(select.getExpr(), record[select.alias]);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (records_1_1 && !records_1_1.done && (_a = records_1.return)) _a.call(records_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return records;
});
sql_mssql_1.DialectMssql.setResultParser(builder_1.QueryFirst, function (record, q) {
    var e_3, _a;
    if (record) {
        try {
            for (var _b = tslib_1.__values(q.criteria.selects), _c = _b.next(); !_c.done; _c = _b.next()) {
                var select = _c.value;
                if (builder_1.isValue(record[select.alias])) {
                    record[select.alias] = sql_mssql_1.DialectMssql.getResult(select.getExpr(), record[select.alias]);
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
    }
    return record;
});
sql_mssql_1.DialectMssql.setResultParser(builder_1.QueryFirstValue, function (result, q) {
    if (builder_1.isValue(result)) {
        result = sql_mssql_1.DialectMssql.getResult(q.value, result);
    }
    return result;
});
sql_mssql_1.DialectMssql.setResultParser(builder_1.QueryList, function (result, q) {
    if (builder_1.isArray(result)) {
        result = result.map(function (item) { return sql_mssql_1.DialectMssql.getResult(q.item, item); });
    }
    return result;
});
//# sourceMappingURL=parsers.js.map