import { ConnectionPool } from 'mssql';
import { DataTypeInputs } from '@typed-query-builder/builder';
import '@typed-query-builder/sql-mssql';
export interface GeneratorTable {
    table: string;
    tableAlias: string;
    tableVariable: string;
    columns: Array<{
        column: string;
        columnAlias: string;
        columnType: DataTypeInputs;
    }>;
    tableDefinition: string;
    primary: string[];
}
export interface GeneratorOptions {
    tableNameAlias: (name: string) => string;
    tableVariableAlias: (name: string) => string;
    columnNameAlias: (name: string) => string;
    tab: string;
    tabDepth: number;
    newline: string;
}
interface SysColumn {
    name: string;
    system_type_id: number;
    max_length: number;
    precision: number;
    scale: number;
    is_nullable: boolean;
    type: string;
    type_max_length: number;
    type_precision: number;
    type_scale: number;
    primary: number;
}
export declare function generate(conn: ConnectionPool, options?: Partial<GeneratorOptions>): Promise<GeneratorTable[]>;
export declare function getColumnType(col: SysColumn): DataTypeInputs;
export declare function getColumnTypePlain(col: SysColumn): DataTypeInputs;
export {};
